// Code generated by protoc-gen-go-grpc. DO NOT EDIT.

package api

import (
	context "context"
	grpc "google.golang.org/grpc"
	codes "google.golang.org/grpc/codes"
	status "google.golang.org/grpc/status"
)

// This is a compile-time assertion to ensure that this generated file
// is compatible with the grpc package it is being compiled against.
// Requires gRPC-Go v1.32.0 or later.
const _ = grpc.SupportPackageIsVersion7

// PowClient is the client API for Pow service.
//
// For semantics around ctx use and closing/ending streaming RPCs, please refer to https://pkg.go.dev/google.golang.org/grpc/?tab=doc#ClientConn.NewStream.
type PowClient interface {
	DoPow(ctx context.Context, opts ...grpc.CallOption) (Pow_DoPowClient, error)
}

type powClient struct {
	cc grpc.ClientConnInterface
}

func NewPowClient(cc grpc.ClientConnInterface) PowClient {
	return &powClient{cc}
}

func (c *powClient) DoPow(ctx context.Context, opts ...grpc.CallOption) (Pow_DoPowClient, error) {
	stream, err := c.cc.NewStream(ctx, &Pow_ServiceDesc.Streams[0], "/io.powsrv.Pow/DoPow", opts...)
	if err != nil {
		return nil, err
	}
	x := &powDoPowClient{stream}
	return x, nil
}

type Pow_DoPowClient interface {
	Send(*PowRequest) error
	Recv() (*PowResponse, error)
	grpc.ClientStream
}

type powDoPowClient struct {
	grpc.ClientStream
}

func (x *powDoPowClient) Send(m *PowRequest) error {
	return x.ClientStream.SendMsg(m)
}

func (x *powDoPowClient) Recv() (*PowResponse, error) {
	m := new(PowResponse)
	if err := x.ClientStream.RecvMsg(m); err != nil {
		return nil, err
	}
	return m, nil
}

// PowServer is the server API for Pow service.
// All implementations must embed UnimplementedPowServer
// for forward compatibility
type PowServer interface {
	DoPow(Pow_DoPowServer) error
	mustEmbedUnimplementedPowServer()
}

// UnimplementedPowServer must be embedded to have forward compatible implementations.
type UnimplementedPowServer struct {
}

func (UnimplementedPowServer) DoPow(Pow_DoPowServer) error {
	return status.Errorf(codes.Unimplemented, "method DoPow not implemented")
}
func (UnimplementedPowServer) mustEmbedUnimplementedPowServer() {}

// UnsafePowServer may be embedded to opt out of forward compatibility for this service.
// Use of this interface is not recommended, as added methods to PowServer will
// result in compilation errors.
type UnsafePowServer interface {
	mustEmbedUnimplementedPowServer()
}

func RegisterPowServer(s grpc.ServiceRegistrar, srv PowServer) {
	s.RegisterService(&Pow_ServiceDesc, srv)
}

func _Pow_DoPow_Handler(srv interface{}, stream grpc.ServerStream) error {
	return srv.(PowServer).DoPow(&powDoPowServer{stream})
}

type Pow_DoPowServer interface {
	Send(*PowResponse) error
	Recv() (*PowRequest, error)
	grpc.ServerStream
}

type powDoPowServer struct {
	grpc.ServerStream
}

func (x *powDoPowServer) Send(m *PowResponse) error {
	return x.ServerStream.SendMsg(m)
}

func (x *powDoPowServer) Recv() (*PowRequest, error) {
	m := new(PowRequest)
	if err := x.ServerStream.RecvMsg(m); err != nil {
		return nil, err
	}
	return m, nil
}

// Pow_ServiceDesc is the grpc.ServiceDesc for Pow service.
// It's only intended for direct use with grpc.RegisterService,
// and not to be introspected or modified (even as a copy)
var Pow_ServiceDesc = grpc.ServiceDesc{
	ServiceName: "io.powsrv.Pow",
	HandlerType: (*PowServer)(nil),
	Methods:     []grpc.MethodDesc{},
	Streams: []grpc.StreamDesc{
		{
			StreamName:    "DoPow",
			Handler:       _Pow_DoPow_Handler,
			ServerStreams: true,
			ClientStreams: true,
		},
	},
	Metadata: "api.proto",
}
